"""用户标签清洗"""
from model.DataBaseUtils import CkUtils,MysqlUtils
import pandas as pd
import sys
ck = CkUtils()
db = MysqlUtils()

def run():
    sql = """
        select channel,
            user_id open_id,
            platform platform_book_name,
                count(1) recharge_count,
               sum(amount) recharge_money,
               max(order_time) last_recharge_time

        from order where status=2 
        group by channel,user_id,platform limit 100"""
    col = ['channel','open_id','platform_book_name','recharge_count','recharge_money','last_recharge_time']

    df = ck.getData_pd(sql,col=col)
    print(df)

    df_channel = get_qc_channel_info()

    result = pd.merge(df,df_channel,how='left',on='channel')
    print(result)

    table = 't_mp_fans'
    keys=['mp_id','open_id']
    tags=['recharge_count','recharge_money','last_recharge_time','platform_book_name']

    db.zx_test.dfUpdate2mysql(result,table,keys,tags)


def get_qc_channel_info():
    sql ="""select cast(id as char) mp_id,nick_name channel from t_mp_account"""
    df = db.zx.getData_pd(sql)
    return df
    # print(df)



if __name__ == '__main__':
    run()
    # get_qc_channel_info()